Subject: bug#46256: [feature/native-comp] AOT eln files ignored if run from build tree

From: Andrea Corallo <[email-masked]>
Date: Sun, 07 Mar 2021 18:53:50 +0000

Eli Zaretskii <[email-masked]> writes:

>> Date: Wed, 03 Mar 2021 20:43:01 +0200
>> From: Eli Zaretskii <[email-masked]>
>> Cc: [email-masked], [email-masked]
>> 
>>        Warning (comp): comp.h:70: Emacs fatal error: assertion failed: NATIVE_COMP_UNITP (a)^M
>> 
>> I also see similar picture in emacs_backtrace.txt:
>> 
>>   emacs_abort at src/w32fns.c:10947
>>   terminate_due_to_signal at src/emacs.c:417
>>   die at src/alloc.c:7452
>>   XNATIVE_COMP_UNIT at src/comp.h:70
>>   load_comp_unit at src/comp.c:4766
>>   syms_of_comp at src/comp.c:5077
>>   Fload at src/lread.c:1548
>> 
>> (My Emacs is compiled with --enable-checking=yes.)

[ Is a while I don not run with --enable-checking=yes, next compilation
  configure it]

> I still keep seeing this from time to time, even though I have a local
> patch to disable the tree-isolate-paths pass.  Suggestions for
> debugging this are welcome.
>
> (I must say that the way the async compilations are run makes it hard
> to track down fatal errors, because I don't even have an easy way of
> knowing which .el file was being compiled when the crash happened.
> Any enhancements of the logging and the diagnostic messages to help in
> these matters will be very welcome.  E.g., how about introducing an
> intermediate log level that would just show the currently compiled .el
> file's name?)

Setting `comp-async-jobs-number' to 1 and looking into the
*Async-native-compile-log* what we are looking for in this case?

  Andrea